From 5b7567b8669bece4570f7229c767e099b33775b4 Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Thu, 26 Mar 2020 14:13:19 +0800
Subject: [PATCH 087/124] ath11k: set WMI pipe credit to 1 for QCA6390

For QCA6390, set wmi credit to 1 to avoid back-to-back write to
shadow register when shadow register is enabled.

Tested-on: QCA6390 WLAN.HST.1.0.1-01230-QCAHSTSWPLZ_V2_TO_X86-1

Change-Id: Iada3c2091808a9dd613c0b7f4a8177a21b23faad
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/core.c | 2 ++
 drivers/net/wireless/ath/ath11k/htc.c  | 6 ++++++
 drivers/net/wireless/ath/ath11k/hw.h   | 1 +
 3 files changed, 9 insertions(+)

diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index 6d5da73..e8e9f0b 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -37,6 +37,7 @@ static const struct ath11k_hw_params ath11k_hw_params_list[] = {
 		.vdev_start_delay = false,
 		.wakeup_mhi = false,
 		.shadow_support = false,
+		.shadow_support_fix = false,
 	},
 	{
 		.name = "qca6390",
@@ -51,6 +52,7 @@ static const struct ath11k_hw_params ath11k_hw_params_list[] = {
 		.vdev_start_delay = true,
 		.wakeup_mhi = true,
 		.shadow_support = true,
+		.shadow_support_fix = true,
 	}
 };
 
diff --git a/drivers/net/wireless/ath/ath11k/htc.c b/drivers/net/wireless/ath/ath11k/htc.c
index b70d6bbc..909a14a 100644
--- a/drivers/net/wireless/ath/ath11k/htc.c
+++ b/drivers/net/wireless/ath/ath11k/htc.c
@@ -536,6 +536,12 @@ int ath11k_htc_wait_target(struct ath11k_htc *htc)
 		return -ECOMM;
 	}
 
+	/* For QCA6390, wmi endpoint uses 1 credit to avoid
+	 * back-to-back write.
+	 */
+	if (ab->hw_params.shadow_support_fix)
+		htc->total_transmit_credits = 1;
+
 	ath11k_htc_setup_target_buffer_assignments(htc);
 
 	return 0;
diff --git a/drivers/net/wireless/ath/ath11k/hw.h b/drivers/net/wireless/ath/ath11k/hw.h
index 0c5614a..95dd62d 100644
--- a/drivers/net/wireless/ath/ath11k/hw.h
+++ b/drivers/net/wireless/ath/ath11k/hw.h
@@ -141,6 +141,7 @@ struct ath11k_hw_params {
 	bool vdev_start_delay;
 	bool wakeup_mhi;
 	bool shadow_support;
+	bool shadow_support_fix;
 };
 
 struct ath11k_fw_ie {
-- 
2.7.4

